extends Node2D


# Declare member variables here. Examples:
var cam_is_caught = false
var stack_is_full = false
var frame = 0
var record
var records_order = ["Records/Record0",
		"Records/Record1",
		"Records/Record2"]


# Called when the node enters the scene tree for the first time.
func _ready():
	$UI.connect("cam_pressed", self, "_on_cam_pressed")


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if cam_is_caught:
		$Camera.set_position(get_global_mouse_position())
		if Input.is_action_just_released("ui_left_click"):
			copy_scene()
	
	if not $Timer.is_stopped():
		var in_frame = []
		for b in $Camera.get_overlapping_bodies():
			if b is RigidBody2D:
				in_frame.append(b)
		record.record(in_frame, $Camera.position, frame)
		frame += 1
		
		
func copy_scene():
	var sprite
	cam_is_caught = false
	for i in range(3):
		record = get_node(records_order[i])
		if record.get_child_count() <= 0:
			for b in $Camera.get_overlapping_bodies():
				record.add_child(b.duplicate(7))
				var double = record.get_child(record.get_child_count()-1)
				double.set_position(b.position - $Camera.position)
				if double.has_node("CollisionShape2D"):
					double.set_collision_layer_bit(0, false)
					double.set_collision_mask_bit(0, false)
					double.set_collision_layer_bit(1, true)
					double.set_collision_mask_bit(1, true)
#				if double.has_node("Sprite"):
#					sprite = double.get_node("Sprite")
#					print(b.get_node("Sprite").get_rect())
#					sprite.set_region(true)
#					sprite.set_region_rect(b.get_node("Sprite").get_rect())
					
			break
		stack_is_full = true
	if stack_is_full:
		pass
	$Timer.start()
	frame = 0
	


#func _unhandled_input(event):
#	if cam_is_caught and event is InputEventMouseButton:
#		if (event.get_button_index() == BUTTON_LEFT
#				and event.is_action_released("ui_left_click")):
#			cam_is_caught = false
#			copy_scene()

func _on_cam_pressed():
	cam_is_caught = true


func _on_Timer_timeout():
	$Camera.set_position(Vector2(-200, 0))
